using System.Diagnostics.CodeAnalysis;
using System.IO;
using CommandLine;
using Newtonsoft.Json;
using OneOfZero.Iptmerge.Exceptions;
using OneOfZero.Iptmerge.Merge;
using OneOfZero.Iptmerge.Merge.Configuration;
using OneOfZero.Iptmerge.Netfilter;
using OneOfZero.Iptmerge.Util;

//
// SPDX-License-Identifier: MIT
// Find the full license text at: https://gitlab.com/1of0/csharp/iptmerge/-/blob/master/LICENSE.md
//

namespace OneOfZero.Iptmerge
{
    public class Program
    {
        public static IConsole Console { get; set; } = new NativeConsole();

        public static void Main(string[] arguments)
        {
            Parser.Default.ParseArguments<Options>(arguments).WithParsed(Execute);
        }

        private static void Execute(Options options)
        {
            if (!File.Exists(options.MergeBehaviourFile))
            {
                throw new ParseException($"File '{options.MergeBehaviourFile}' does not exist");
            }

            var netfilterParser = new NetfilterParser();
            var stateMerger = new StateMerger();

            var mergeBehaviour = JsonConvert.DeserializeObject<MergeBehaviour>(
                File.ReadAllText(options.MergeBehaviourFile)
            );

            var generatedState = netfilterParser.ParseFile(options.GeneratedStateFile);
            var runningState = string.IsNullOrEmpty(options.RunningStateFile)
                ? netfilterParser.ParseString(Console.ReadStandardInputAsString())
                : netfilterParser.ParseFile(options.RunningStateFile);

            var merged = stateMerger.Merge(runningState, generatedState, mergeBehaviour);
            Console.WriteStandardOutput(merged.ToString());
        }

        [SuppressMessage("ReSharper", "AutoPropertyCanBeMadeGetOnly.Local")]
        [SuppressMessage("ReSharper", "ClassNeverInstantiated.Local")]
        private class Options
        {
            [Value(
                0,
                MetaName = "merge-behaviour-file",
                HelpText = "File containing a JSON tree with settings for the generator.",
                Required = true
            )]
            public string MergeBehaviourFile { get; set; } = "";

            [Value(
                1,
                MetaName = "generated-state-file",
                HelpText = "File containing an iptables-save formatted configuration that will be used as master " +
                           "template for the restore file.",
                Required = true
            )]
            public string GeneratedStateFile { get; set; } = "";

            [Value(
                2,
                MetaName = "running-state-file",
                HelpText = "File containing an the running iptables configuration as generated by iptables-save. " +
                           "If not provided the running state should be provided through STDIN.",
                Required = false
            )]
            public string? RunningStateFile { get; set; } = null;
        }
    }
}
